****PROGRAM BY: TERESA FORT;
***WRITTEN ON: 03-05-2013;

***LAST MODIFIED ON: 11-23-14 ;
***LAST MODIFIED BY: TFP;

**THIS PROGRAM MAKES 2007 DATA FROM THE CMF AND CWH THAT INCLUDES THE SPECIAL INQUIRY QUESTIONS;

***This program makes an establishment-level dataset of the Census special estab questions;

option obs=max;
*options obs=100000;


*Assign libnames;
libname aer "YOUR DATA DIRECTORY NAME HERE" ; 



**Pull in data from cmf;
data manuf(keep=design contract activity survuid census);
  length design $8 activity $8 contract $8 ;
  set cmf.cmf2007si(keep=survu_id otesac otesaca otesacp rename=(survu_id=survuid));
  if otesac=1 then design='YES';
  if otesac=2 then design='NO';
  if otesaca=1 then contract='IN US';
  if otesaca=2 then contract='OUT US';
  if otesaca=3 then contract='NO';
  if otesacp=1 then activity='CONTRACT';
  if otesacp=2 then activity='MANUF';
  if otesacp=3 then activity='RESALES';
  if otesacp=4 then activity='OTHER';
  census='MANUF';
run; 


**Pull in questions from 2007 wholesale census;

/*
Documentation from the file: trailer_defns_updated.csv

"Does this establishment design, engineer, or formulate the manufactured products sold, produced, or shipped by this location: Y = Yes, N = No",0317,2007

Does this establishment purchase contract manufacturing services from other establishments to process materials or components that this establishment controls: 1 = Primarily with Establishments in the US; 2 = Primarily with Establishments Outside the US; 3 = No,0495,2007

*/



  data whole;
      set cwh.cwh2007tral (rename=(survu_id=survuid));
       length census $ 5 name $8 value $8 ;
    *where itemcode='0318' | itemcode='0319' | itemcode='0362' | itemcode='0363' | itemcode='0364' | itemcode='0365' | itemcode='0496'
    | itemcode='0497' | itemcode='0498' ;

    where itemcode='0317' | itemcode='0362' | itemcode='0363' | itemcode='0364' | itemcode='0365' | itemcode='0495' ;
    if useflag='U';
    
    census='WHOLE';
     
   *Design question;
    if itemcode='0317' then do;
	name='design';
	if itemvalue=1 then value="YES";
	if itemvalue=2 then value="NO";
	end;
    
    *Primary activity question;
    if itemcode='0362' & itemvalue=1 then do;
	name='activity';
	value="CONTRACT";
	end;
    if itemcode='0363' & itemvalue=1 then do;
	name='activity';
	value="MANUF";
	end;
    if itemcode='0364' & itemvalue=1 then do;
	name='activity';
	value="RESALES";
	end;
    if itemcode='0365' & itemvalue=1 then do;
	name='activity';
	value="OTHER";
	end;

   *CMS Purchase activity;
   if itemcode='0495' then do;
       name="contract";
       if itemvalue=1 then value="IN US";
       if itemvalue=2 then value="OUT US" ;
       if itemvalue=3 then value="NO";
       end;   
  run;

/*
proc freq data=whole;
    tables itemcode*itemvalue;
run;
*/

**Drop activity if more than one specified;
proc sort data=whole;
    by survuid name  value;
run;

data whole2 dropped;
    set whole;
    by survuid name value;
    if name='design' | name='contract' | (name='activity' & first.name=1 & last.name=1) then output whole2;
    else output dropped;
run;


**Transpose data;
proc sort data=whole2;  by census survuid name; run;

proc transpose data=whole2 out=whole_trans(drop=_NAME_);
   by census survuid;
   id name;
   var value;
run;

**Check against NBER FGP Paper;  
proc freq data=whole_trans;
    tables design*contract*activity;
run;


**Combine censuses;
data censuses;
  set manuf whole_trans;
run;

**Ensure that survuid is unique by census;
proc sort data=censuses nodupkey out=check; by census survuid; run;


*************** Get alphas and remaining Census vars  ************;
*Make own-per variable for wholesal;
data census07(drop=temp);
   set censuses;
   own_per=1*temp;
   if survuid^=' ';
run;

%let cmf_list=survu_id tabbed tvs sw alpha ar cou cp ein te oe naics_old naics_new pw empq1_dcurr12 tab tae cw rcw exp numprods va ow ww cpc ecom_pct
 ecom_any ipt sp form_mailed form_proc et cdapr cexso tps cpc_ei cpc_f ecom_any_f ecom_pct_f ecom_pct_ei pps fipsst only_estab tract wt; 

%let cwh_list=survu_id tabbed sales alpha county_fips ein active empl gross_margin naics_old pay_ann merch merch_r optype optype_mult naics_new pay_q1 invboy inveoy 
 ecom_gt50pct pctbline1 pctbline2 response_type state_fips tract; 

**Pull in census data;
data tab_manuf(drop=temp temp2);
  length temp2 $ 11 ein $ 9;
  set cmf.cmf2007(keep=&cmf_list rename=(survu_id=survuid sw=payann tvs=sales empq1_dcurr12=empl ein=ein_t fipsst=st cou=county));
  census="MANUF";
 *Make fixed ein variable;
  temp=1000000000+ein_t;
  temp2=temp;
  ein=substr(left(trim(temp2)),2);
run;       

data tab_whole;
  set cwh.cwh2007base(keep=&cwh_list rename=(survu_id=survuid pay_ann=payann state_fips=st county_fips=county));
  census="WHOLE";
run;

data tab_whole_misc;
  set cwh.cwh2007misc(keep=survu_id form_mailed form_edit form_proc form_remail rename=(survu_id=survuid));
run;

proc sort data=tab_whole_misc; by survuid; run;

data tab_whole2;
  merge tab_whole(in=a) tab_whole_misc;
  by survuid;
  if a=1;
run;


data tabbed;
    length naics02 $ 6;
    
  set tab_whole2 tab_manuf ;
  naics02=substr(naics_old,1,6);
  
   if alpha^=' ' then firmid=alpha||'0000';
   ein=left(trim(ein));
   if alpha =' ' then firmid='0'||ein;
run;
   
proc sort data=census07;  by census survuid; run;  
proc sort data=tabbed   nodupkey;  where survuid^=' ';  by census survuid; run;


*Add tabbed info to census data.  Limit to records with tabstat=Y;
data census07 missing;
  merge census07(in=a) tabbed(in=b);
  by census survuid;
  if tabbed='Y' then output census07;
  if a=1 and b=0 then output missing;
run;

*Separate dupes;
proc sort data=census07; by survuid; run;
data census07 dupes;
  set census07;
  by survuid;
  if first.survuid=1 and last.survuid=1 then output census07;
  else output dupes;
run;

data dupes_add;
  set dupes;
  by survuid;
  if first.survuid=1;
run;

%let keeplist=ar activity cdapr cexso census contract design ein empl pctbline1 pctbline2 firmid form_mailed form_edit 
 form_remail form_proc invboy inveoy merch merch_r naics02 naics_new numprods oe only_estab optype optype_mult ow payann  pay_q1  pps pw 
 response_type rcw sales sp st survuid te tab tae va wt ww gross_margin;


data census07(keep=&keeplist cfn);
  retain &keeplist;
  set census07 dupes_add;
  cfn=survuid;
run;
***22 dupes, add the ones from Manuf  Now there arent any dupes?;

**********************;


***Put LBDNUMS on the data;

%macro lbd(y);
    data lbd&y;
	set lbd.lbd&y.c(keep=cfn lbdnum emp pay firstyear lastyear firmid rename=(emp=emp_lbd pay=pay_lbd));
    run;
    proc sort data=lbd&y;
	by cfn;
    run;
    proc sort data=census07 out=estabs&y;
	by cfn;
    run;
    data estabs&y lbd_miss&y;
	merge lbd&y(in=a) estabs&y(in=b);
	by cfn;
	if lbdnum=' ' then lbdnum="Miss &y";  *Need to avoid null lbdnums for the merge later on;
	if a=0 & b=1 then output lbd_miss&y;
	if b=1 then output estabs&y;
    run;
%mend;
%lbd(2007);


**Output final dataset with additional measures;
data aer.estabs_2007 (drop=naics_new);
 length naics07 $ 6 ;
  set estabs2007;

 *Make naics07;
  naics07=substr(naics_new,1,6);

 *Define FGP establishments;
 if design="YES" & (contract="IN US" | contract="OUT US") then fgp="YES";
 if design="YES" & (activity="MANUF" | activity="CONTRACT" | activity="OTHER") then fgp="YES";
 if design="NO" | (activity="RESALES" & contract="NO") then fgp="NO"; 

 *Identify establishments in industries that were NOT asked the FGP questions;
 industry_asked='yes';
 if naics07='423210' | naics07='423220' | naics07='423410' | naics07='423420' | naics07='423440' | naics07='423450' | naics07='423460' | naics07='423490' 
  | naics07='423710' | naics07='423720' | naics07='423730' | naics07='423740' | naics07='423840' | naics07='423990' | naics07='424610' | naics07='424690' 
  | naics07='424710' | naics07='424720' | naics07='424910' | naics07='424990' | naics07='425110' | naics07='425120'  then industry_asked='no'; 
run;







